import { geoMercator, geoPath,select } from 'd3';
import {useRef,useEffect} from 'react'


const transitionDuration = 500;



export const Map = ({data, width, height, onMapClick}) => {
// const projection = geoMercator().scale(700).translate([width/2, height/2]).center([73,19.7]);
// const path = geoPath(projection);
  const svgRef = useRef();
	const wrapperRef = useRef();

  
	const mercator = geoMercator().scale(850).translate([width/2, height/2]).center([78,22.9]);
	const pathGenerator = geoPath().projection(mercator);

  
  useEffect(()=>{
  const svg = select(svgRef.current);
    
  const zoomed = (e) => {
    // console.log(e)
    svg.style("stroke-width", 1.5 / e.transform.k + "px");
    svg.attr("transform", e.transform); // updated for d3 v4
}
	let zzoom = d3.zoom().scaleExtent([1, 8]).on("zoom", zoomed);
  
  const zoomToBoundingBox = d => {
      console.log(d)
let bounds = pathGenerator.bounds(d),
    dx = bounds[1][0] - bounds[0][0],
    dy = bounds[1][1] - bounds[0][1],
    x = (bounds[0][0] + bounds[1][0]) / 2, 
    y = (bounds[0][1] + bounds[1][1]) / 2, 
    
    scale = Math.min(8, 0.9 / Math.max(dx / width, dy / height)),
    // scale = Math.max(1, Math.min(8, 0.9 / Math.max(dx / width, dy / height))),
    translate = [width/2 -x, height/2-y];   
    // translate = [width / 2 - scale * x * .15, height / 2 - scale * y *.38];
  svg.transition().duration(transitionDuration).call(
  zzoom.transform, d3.zoomIdentity.translate(translate[0],translate[1]).scale(scale)
  ); 

}
    
  svg
    .selectAll(".polygon")
    .data(data)
    .join("path").attr("class", "polygon") 
    .attr("d" ,feature => pathGenerator(feature))
    .on("click",(e ,d)=>{
      zoomToBoundingBox(d);
    console.log(pathGenerator.bounds(d));

  	onMapClick(d.properties.NAME1_)
  });
  },[data]);
  
  

	return (
      <svg className = "svg-map" width={width} height={height} ref={svgRef} ></svg>
  )
};
